
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - --
        Copyright:    s+p Software und Consulting AG
        Autor:        M. Pawlowski
        Datum:        26.08.2004
       
   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */


/* - - - - - - - - - - - - - - - globale Variablen - - - - - - - - - - - - - - */

var	Global_blnIExplorer = document.all;								// Browser als IE identifiziert 
var Global_blnEventsGesetzt = false;								// wurden Events initalisiert true / false
var Global_arrCBOliste = new Array;									// Array welches das Control speichert - - fr den Fall das mehrere CBO in einer Seite verwendet werden
var Global_intComboBoxHeight = 100;									// feste Hhe des ComboBoxMenues
var Global_blnEventsInitalisiert = false							// Boolean Wert ob die Events initalisiert sind (keine doppelte Initalisierung)
var Global_CBOname;													// Name des aktiven Objektes

var Global_objCBOs = new Object();									// Array welches alle CBO Objekte beinhaltet







/* - - - - - - - - - - - - - - - new ComboBox Objekt  - - - - - - - - - - - - - - */

function spComboBox() 
{
	if(arguments.length==0) 
	{
		self.status = "Fehler beim Erstellen der Combobox !";
	}


	//Properties
	this.CBOname				= arguments[0];						// Interner Name der ComboBox
	this.intTXTwidth;												// Breite des Textfeldes
	this.intTXTfontsize;											// SchriftGrsse des TextFeldes
	this.scriptANDimagePath;										// Pfad wo das Script bzw das Bild liegt
	this.blnEnabled;												// ComboBox aktiviert/deaktiviert
	this.intUniqueID;												// eindeutige ID des Controls
	this.blnAutopostback;											// Postback aktiv / inaktiv
	this.Items					= new Array();						// Array der gesamten Items
	this.Items2show				= new Array();						// Array welche nach dem Filtern angezeigt werden
	this.opened					= false;							// speichert ob CBO geffnet oder geschlossen ist
	this.HighLightedItem;											// aktuell selektiertes Item --> Speicherung um es wieder deselektieren zu knnen
	this.ActuellItem			= new Object;						// aktuell ausgewhltes Item --> Speicherung um es bei Verlassen der ComboBox ohne Auswahl wieder herstellen zu knnen
	this.intActuellItemIndex;										// Index des aktuell ausgewhlten CBO Items
	this.blnFiltering			= false;							// Sollen Items gefiltert werden oder nicht
	this.AutoPostBack			= false;							// boolean AutoPostBack der Seite 
	this.intTabIndex			= -1;								// Tabreihenfolgenindex
	
		
	this.OuterDIV				= document.createElement("div");	// Dom-Object das in das Dokument eingehangen wird
	this.DataTable;													// HTML - Tabelle zur Darstellung der Daten
	this.DataTableLayer;											// Layer, welcher die DatenTabelle beinhaltet
	this.TextBox				= this.OuterDIV.childNodes[0];		// Textfeld zur Anzeige der Auswahl bzw zur Suche
	
	this.ComboBoxBezeichnung	= arguments[0];						// Interner Name der ComboBox
	this.ParentOFcombobox		= arguments[1]||document.body;		// Parent der ComboBox zum einhaengen im DOM
	
	this.hiddenTextField		= arguments[2];						// Textfeld zum zwischenspeichern der Werte


	//Methods
	this.buildTextBox			=	spComboBox_buildTextBox;		// erstelle die Textbox samt Bild
	this.enable					=	spComboBox_enable;				// enable / disable combobox
	this.addItem				=	spComboBox_addItem;				// Item hinzufuegen
	this.initEvents				=	spComboBox_initEvents;			// Events des Control festlegen
	this.toggle					=	spComboBox_toggle;				// Entscheidung ob Menue auf- oder zugeklappt wird
	this.open					=	spComboBox_open;				// ffnen der ComboBox
	this.close					=	spComboBox_close;				// Schliesst der ComboBox 
	this.buildDataTable			=	spComboBox_BuildDataTable;		// Tabelle mit Daten bauen
	this.buildDataSource		=	spComboBox_BuildDataSource;		// Datengrundlage erstellen / Items filtern und in Items2show speichern
	this.setDataTablePosition	=	spComboBox_setDataTablePosition;// kongrete Postion der Datentabelle setzen (Browserabhngig)
	this.setRealItemWidth		=	spComboBox_setRealItemWidth;	// kongrete Breite der Datentabelle setzen (Browserabhngig)
	this.hideHTMLElements		=	spComboBox_hideHTMLElements;	// Versteckt HMTL Elemente damit sie hinter dem Control liegen

	
	//Events
	this.Blur					=	spTextBox_blur;					// Event Methode wenn TextBox verlassen wird
	this.MouseClick				=	Document_mouseClick;			// Event Methode wenn Mouse geclickt wird
	this.KeyPress				=	Document_KeyPress;				// Event Methode wenn Keyboard button gedrckt wird
	this.HighLightItem			=	spComboBox_HighLightItem;		// markieren, demarkieren von Item
	this.onMouseOverItem		=   spComboBox_onMouseOverItem;		// Methode falls mouse ber einem Item steht
	this.chooseItem				=	spComboBox_chooseItem;			// Auswahl eines Items und setzen in die TextBox
																								 

	//Aufgaben beim Init ausfhren
	this.ParentOFcombobox.appendChild(this.OuterDIV);				// Layer in Seite hngen
	Global_arrCBOliste[this.CBOname] = this;						// aktuelles Control in Array speichern
	Global_objCBOs[this.CBOname] = this;
}






/* - - - - - - - - - - - - - - - Built Methods - - - - - - - - - - - - - - */

//Aufbau der ComboBox
function spComboBox_buildTextBox()
{
	//TextFeld erzeugen und einhaengen 
	this.TextBox			= document.createElement("INPUT")	
	this.TextBox.type		= "text";
	this.TextBox.name		= this.ComboBoxBezeichnung + 'txt';
	this.TextBox.id			= this.ComboBoxBezeichnung + 'txt';
	this.TextBox.tabIndex	= this.intTabIndex;
	
	this.TextBox.style.width		= this.intTXTwidth ;
	this.TextBox.style.height		= 20 ;
	this.TextBox.style.fontSize		= this.intTXTfontsize;
	this.TextBox.style.verticalAlign= "middle";
	this.TextBox.className			= "combo-input"

	if (this.enable == false) {
		this.TextBox.disabled=true;
	}
	
	//this.OuterDIV.appendChild(this.TextBox);

	this.cmdbutton = document.createElement("IMG");
	this.cmdbutton.src = this.scriptANDimagePath + 'Search_XPSilver.gif';
	
	//this.cmdbutton.width = parseInt(this.intTXTfontsize) + 7;
	//this.cmdbutton.height = parseInt(this.intTXTfontsize) + 7;
	this.cmdbutton.width = 17;
	this.cmdbutton.height = 20;
	this.cmdbutton.border = "0";
	this.cmdbutton.align = "middle";
	this.cmdbutton.name	= this.ComboBoxBezeichnung+'cmdbutton';
	this.cmdbutton.id = this.ComboBoxBezeichnung+'cmdbutton';

	if (this.enable == false) {
		this.cmdbutton.disabled=true;
		this.cmdbutton.src = this.scriptANDimagePath + 'Search_XPSilverDisabled.gif';
		this.TextBox.className			= "combo-input-disabled"
	}
	//this.OuterDIV.appendChild(this.cmdbutton);

	
	this.mDisplayTable = document.createElement("TABLE");
	
	this.mDisplayTable.setAttribute("class","combo-list-width")
	this.mDisplayTable.setAttribute("cellpadding", 0, false);
	this.mDisplayTable.setAttribute("cellspacing", 0, false);
	this.mDisplayTable.setAttribute("width", this.intTXTwidth, false);
	this.mDisplayTable.setAttribute("border", 0	, false);
	this.mDisplayTable.innerText = '';

	this.OuterDIV.appendChild(this.mDisplayTable);
	//this.OuterDIV.setAttribute("width","100%", false);
	this.OuterDIV.style.width = "100%";
	tr = this.mDisplayTable.insertRow(this.mDisplayTable.rows.length);
	td = tr.insertCell(tr.cells.length);
	td.setAttribute("noWrap","noWrap");	
	td.setAttribute("width","100%");	
	td.appendChild(this.TextBox);
	
	td = tr.insertCell(tr.cells.length);
	td.setAttribute("Width","17");	
	td.setAttribute("noWrap","noWrap");	
	td.appendChild(this.cmdbutton);

	//this.OuterDIV.width = this.ParentOFcombobox.width;
	this.cmdbutton.onfocus = function () {this.blur();};
	
	if (Global_blnEventsInitalisiert == false && this.enable == true )
	{
		Global_blnEventsInitalisiert = true;
		this.initEvents(this.ComboBoxBezeichnung);					//Events fr das Control setzen
	}
}


//items hinzufuegen
function spComboBox_addItem() 
{
	var intCount, intCountArguments;
	intCountArguments = arguments.length;
	for(intCount = 0; intCount < intCountArguments; intCount++) 
	{
		this.Items[this.Items.length]=arguments[intCount];
	}
}


// construkter des ComboboxItemObjektes
function spComboBoxItem(value,text,selected) 
{
    this.text  = text;
    this.value = value;
    this.selected = selected;
}


//auswahlfenster bauen
function spComboBox_BuildDataTable() 
{
	var str, intCount;
	var tr, td;
	
	//	DataTableLayer anlegen
	// Wenn Layer schon existiert keinen neuen anlegen
    if (!this.DataTableLayer)
    { 
		this.DataTableLayer = document.createElement("DIV");
		this.OuterDIV.appendChild(this.DataTableLayer); 
		this.DataTableLayer.style.position='absolute';
		this.DataTableLayer.innerHTML = '';
		this.DataTableLayer.style.height = Global_intComboBoxHeight;
		this.DataTableLayer.style.zIndex = 5;
		this.DataTableLayer.className = "combo-list";
		this.DataTableLayer.id = this.ComboBoxBezeichnung + '_DataTableLayer'
    }
	
	// DataTable anlegen
	// wenn schon vorhanden entfernen und neu
	if (this.DataTable)
    { 
		this.DataTableLayer.removeChild(this.DataTable);	
		this.DataTableLayer.innerHTML = "";
		
		this.DataTable = document.createElement("TABLE");
		this.DataTable.setAttribute("border","0")
    }
    else
    {
		this.DataTable = document.createElement("TABLE");
		this.DataTable.setAttribute("border","0")
	}	  
	
	this.DataTable.setAttribute("class","combo-list-width")
	this.DataTable.setAttribute("cellpadding", 0, false);
	this.DataTable.setAttribute("cellspacing", 0, false);
	this.DataTable.ID =  this.CBOname + '_DataTable';
	this.DataTable.innerText = '';
	
	// Datenzeilen in DataTable einfgen 
	for(intCount = 0; intCount < this.Items2show.length; intCount++)
	{     
		tr = this.DataTable.insertRow(this.DataTable.rows.length);
		td = tr.insertCell(tr.cells.length);
	    td.setAttribute("noWrap","noWrap");
		
		
		td.Parent = this;
		
		//Mouse Item Events
		td.onmouseover = function () { td.Parent.onMouseOverItem(this.parentNode.rowIndex, this); };
		td.onclick = function () {td.Parent.chooseItem(this.Parent.Items2show[this.parentNode.rowIndex].value,this.Parent.Items2show[this.parentNode.rowIndex].text, this, this.parentNode.rowIndex); td.Parent.close()};  

		if (this.Items2show[intCount].text.length > 0 )
		{
			td.innerHTML = strHTMLEncode(this.Items2show[intCount].text);
		}
		else
		{
			td.innerHTML = "&nbsp;";
		}
	    td.id = this.CBOname + '_DatenZelle_' + intCount; 
		
		if (this.Items2show[intCount].selected == '0') 
		{
			td.className = "combo-item";
		}
		else 
		{
			td.className = "combo-hilite";
			this.intHighLightedItem = intCount;
			this.HighLightedItem  = td;
			this.ActuellItem = td;
			this.intActuellItemIndex = intCount;
			
			this.Items2show[intCount].selected = '0';
		}
	}
	this.DataTableLayer.style.display='block';
	this.DataTableLayer.appendChild(this.DataTable);
	
	// wenn Datentabelle kleiner als der DatenTableLayer --> DatentableLayer verkleinern
	if (this.DataTable.offsetHeight <= this.DataTableLayer.offsetHeight)
	{
		if (Global_blnIExplorer)
		{
			this.DataTableLayer.style.height = this.DataTable.offsetHeight + 4;	
		}
		else
		{
			this.DataTableLayer.style.height = this.DataTable.offsetHeight;	
		}
	}
	else
	{
		this.DataTableLayer.style.height = Global_intComboBoxHeight;
	}
	
    this.setRealItemWidth();
}






/* - - - - - - - - - - - - - - - Misc Methods - - - - - - - - - - - - - - */

// combobox enable / disable
function spComboBox_enable(p_enabled) 
{
	this.enable = p_enabled
}

// Entscheidung ob CBO auf- oder zugeklappt wird
// Parameter p_blnClickONbutton gibt an ob auf Button oder daneben geclickt wurde
function spComboBox_toggle(p_blnClickONbutton) 
{
	if (this.opened == true)
	{
		this.close();	
	}
	else if (p_blnClickONbutton == true)
	{
		this.open();
	}
}


// Methode zum ffnen der ComboBox - - Layer zeigen 
function spComboBox_open() 
{
	Global_objCBOs[Global_CBOname].opened = true;
	Global_objCBOs[Global_CBOname].buildDataSource();
	Global_objCBOs[Global_CBOname].buildDataTable(Global_objCBOs[Global_CBOname].items2show);
	Global_objCBOs[Global_CBOname].setDataTablePosition();
	Global_objCBOs[Global_CBOname].HighLightItem(Global_objCBOs[Global_CBOname].intActuellItemIndex, Global_objCBOs[Global_CBOname].ActuellItem);
	Global_objCBOs[Global_CBOname].hideHTMLElements(Global_objCBOs[Global_CBOname].DataTableLayer);
}


// Methode zum Schliessen der ComboBox - - verstecken
function spComboBox_close()
{
	this.opened = false;
	this.DataTableLayer.style.display="none";											// Datenlayer verstecken
	if (document.all) {
		document.all("SP_ZIndexFix_" + this.DataTableLayer.id).style.display = "none";		// Iframe welcher HMTL Elemente versteckt, versteckensel
	}
} 


// Methode um aktuelle Breite des Datenlayers in Abhngigkeit zur Lnge der Items zu ermitteln
// wenn nicht IE dann werden 6 Pixel angehangen wegen unterschiedlicher Browserdarstellung ansonsten immer so breit wie die Textbox
function spComboBox_setRealItemWidth()
{
	var intWidth;
	var intDiff;
	
	intDiff = this.DataTableLayer.offsetWidth-this.DataTableLayer.clientWidth; // breite des Scrollbalkens
	
	// Breite ermitteln
	if (Global_blnIExplorer)
	{
		this.DataTable.style.width = "10%";
		intWidth = this.DataTable.offsetWidth + intDiff; // (this.DataTableLayer.offsetWidth-this.DataTableLayer.clientWidth); //-(this.DataTableLayer.offsetWidth);
	}
	else
	{
	//this.DataTable.style.width = "100%";
		intWidth  = this.DataTable.offsetWidth + intDiff - 2; //(this.DataTableLayer.offsetWidth-this.DataTableLayer.clientWidth)- 2; //(this.DataTableLayer.offsetWidth) -2 ;
	}
	
	// wenn DataTableLayer und Datatable kleiner als Textbox dann auf Breite der Textbox transformieren 
	if (intWidth <= (this.OuterDIV.offsetWidth ))
	{
		if (Global_blnIExplorer)
		{
			this.DataTableLayer.style.width = this.OuterDIV.offsetWidth -4;
			this.DataTable.style.width = this.OuterDIV.offsetWidth - intDiff -6;
		}
		else
		{
			this.DataTableLayer.style.width = this.OuterDIV.offsetWidth -8;
			this.DataTable.style.width = this.OuterDIV.offsetWidth - intDiff -6;
		}
	}	
	else
	{
		this.DataTable.style.width = "100%";
		this.DataTableLayer.style.width = this.DataTable.offsetWidth + intDiff ;
		this.DataTable.style.width = this.DataTable.offsetWidth ; //achten wegen scrollbar
	}
	
}


//Methode zum Ermitteln und Setzen der korrekten Position des Layers zum Darstellen der Items
function spComboBox_setDataTablePosition()
{ 
	var intLeft;
	var intTop;
	
	//Left ermitteln
	intLeft = this.OuterDIV.offsetLeft;
    tmpElement = this.OuterDIV.offsetParent;
    while (tmpElement != null) 
    {
        intLeft += tmpElement.offsetLeft;
        tmpElement = tmpElement.offsetParent;
    }
    
    //Top ermitteln
    intTop = this.OuterDIV.offsetTop;
    tmpElement = this.OuterDIV.offsetParent;
    while (tmpElement != null) 
    {
        intTop += tmpElement.offsetTop;
        tmpElement = tmpElement.offsetParent;
    }
    intTop = intTop + this.OuterDIV.offsetHeight;// + 3;
    
    //Werte setzen	
	this.DataTableLayer.style.left = intLeft +2;
	this.DataTableLayer.style.top  = intTop;			
}


// verstecken von Elemente wie WindowsComboBoxen (for IE only)
function spComboBox_hideHTMLElements(p_objDataTableLayer)    
{
	if(Global_blnIExplorer) 
	{
		var strIFrameName = "SP_ZIndexFix_"+p_objDataTableLayer.id; 

		if (!document.all[strIFrameName])
		{
			var vIFrame = "<iframe src='javascript:false;' id='" + strIFrameName +
						  "' scrolling='no' frameborder='0'  " +
						  "style='position:absolute;top:0x;left:0px;" + 
						  "display:none'></iframe>";
		    var vElement = p_objDataTableLayer.parentElement;
				
			vElement.insertAdjacentHTML('beforeEnd',vIFrame);
		}
		
		if (document.all[strIFrameName])
		{
			var vStyle = document.all[strIFrameName].style;
			vStyle.pixelTop = p_objDataTableLayer.style.pixelTop;
			vStyle.pixelLeft = p_objDataTableLayer.style.pixelLeft;
			if (Global_blnIExplorer) 
			{
				vStyle.pixelWidth = p_objDataTableLayer.offsetWidth ;
				vStyle.pixelHeight = p_objDataTableLayer.offsetHeight;
			}
			else
			{
				vStyle.pixelWidth = p_objDataTableLayer.offsetWidth + 6;
				vStyle.pixelHeight = p_objDataTableLayer.offsetHeight + 6;
			}
						
			var vZIndex = 2; 
			vStyle.zIndex = vZIndex;			
			vStyle.filter='progid:DXImageTransform.Microsoft.Alpha(style=0,opacity=0)';
			vStyle.display='block';
			vStyle.frameborder=1;
		}
	}
}






/* - - - - - - - - - - - - - - - Event Methods - - - - - - - - - - - - - - */

//Events setzen
function spComboBox_initEvents(objName) 
{



	if (document.addEventListener) 
	{

/*

		document.addEventListener("keydown", Document_KeyPress, false );
		document.addEventListener("keyup", Document_KeyPress, false );
		document.addEventListener("onkeyup", Document_KeyPress, false );
		document.addEventListener("mousedown", Document_mouseClick, false );
		
*/
		if(document.captureEvents)
			document.captureEvents(Event.KEYDOWN | Event.KEYPRESS | Event.KEYUP);
		document.onkeydown  = Document_KeyPress;
		document.onkeyup    = Document_KeyPress;
		document.onkeypress = Document_KeyPress;
		//document.mousedown = Document_KeyPress;
		document.addEventListener("mousedown", Document_mouseClick, false );
		eval('document.getElementById("' + objName + 'txt").addEventListener("onblur", spTextBox_blur, true );');
	}
	else if (document.attachEvent) 
	{
	

		document.attachEvent("onkeydown", function () { Document_KeyPress(window.event);  } );
		document.attachEvent("onmousedown", function () { Document_mouseClick(window.event)} );
        document.attachEvent("onkeyup", function () { Document_KeyPress(window.event)} );		
		
		eval('document.getElementById("' + objName + 'txt").onblur = function () { spTextBox_blur(\'' + objName + '\');}') ;
	
	}
	
	Global_blnEventsGesetzt = true;
}
	
//Event zum Verlassen der TextBox
function spTextBox_blur()
{
	var objCurrentCBO, intCount;
	
	for (intCount = 0; intCount < Global_arrCBOliste.length; intCount++)
	{
		objCurrentCBO = Global_arrCBOliste[intCount];
		objCurrentCBO.toggle(false);
	} 
}


//Events falls mouse taste gedrckt wird
function Document_mouseClick(objEvent)
{
	var objElement,intCount, objCurrentCBO;
	objClickedElement = objEvent.target ? objEvent.target : objEvent.srcElement;
	
	while (objClickedElement.nodeType != 1) 
		objClickedElement	= objClickedElement.parentNode;
	var objElementCSSclass	= objClickedElement.className;
	
	if(objElementCSSclass.indexOf("combo-") != 0)							// wenn im CSS "Combo" steht dann ist es ein keine Aktion weil die Aktion vom Item selbst ausgefhrt wird
	{
		
		//aktiven Namen der CBO setzen
		PressedElement = objEvent.target ? objEvent.target : objEvent.srcElement;
		ElementBezeichnung = PressedElement.id.split("cmdbutton")[0];
		if (objElementCSSclass.indexOf("cbo") > 0 || objClickedElement.id.indexOf("cmdbutton") > 0)
		{
			objCBO = window[ElementBezeichnung];							// spComboBox holen
			Global_CBOname = objCBO.CBOname;
		
			if (objClickedElement.id.indexOf("cmdbutton") > 0)				// wenn im CSS "cmdButton" steht dann ist es ein Click auf den Button
			{
				objCBO.toggle(true);
			}
			else															// ansonsten Click ausserhalb des Controls
			{
				objCBO.toggle(false);									
			}	
		}
		else																// Click ausserhalb einer ComboBox --> alle CBOs schliessen
		{
			for (CBOitem in Global_objCBOs)
			{
				if(objClickedElement != '[object XULElement]')              // [object XULElement] is scrollbar (Mozilla only) BUG in Mozilla
			    {
				    Global_objCBOs[CBOitem].toggle(false);		
				}										
			} 
		}
	}
}

//Event falls eine Keyboardtaste gedrckt wird
function Document_KeyPress(e)
{
	var PressedElement, PressedKeyCode, ElementClassName, ElementBezeichnung, objCBO;
	
	this.blnFiltering = false;
	
	PressedElement = e.target ? e.target : e.srcElement;
	PressedKeyCode  = e.keyCode;
	ElementClassName = PressedElement.className;
	
	// Events welche ausgelst werden, wenn CBO als aktives Element gewhlt ist
	if(ElementClassName.indexOf("combo-") == 0)	   						// berprfen ob Element eine Combobox ist
	{		
		if(ElementClassName.split("-")[1] == "input")					// berprfen ob Element ein Eingabefeld ist
		{	
			ElementBezeichnung = PressedElement.id.split("txt")[0];
			objCBO = window[ElementBezeichnung];						// spComboBox holen
			Global_CBOname = objCBO.CBOname;
			
				switch(PressedKeyCode) 
				{
					case 13:// Enter
						if (e.type == 'keydown') 
						{
							if (Global_objCBOs[Global_CBOname].opened) 
								{
									try 
									{		
										//highlighted Item in Textbox bertragen und so auf Actuell  Item setzen
										Global_objCBOs[Global_CBOname].chooseItem(Global_objCBOs[Global_CBOname].Items2show[Global_objCBOs[Global_CBOname].intHighLightedItem].value,Global_objCBOs[Global_CBOname].Items2show[Global_objCBOs[Global_CBOname].intHighLightedItem].text, Global_objCBOs[Global_CBOname].HighLightedItem, Global_objCBOs[Global_CBOname].intHighLightedItem);
									}
									catch(e) {};
									Global_objCBOs[Global_CBOname].toggle(false);
									window.event.returnValue = false;
									window.event.cancelBubble = true;
								}
							}
							break;
					case 27:// Escape
						if (e.type == 'keydown') 
						{
							if (Global_objCBOs[Global_CBOname].opened)
							{
								Global_objCBOs[Global_CBOname].toggle(false);
							}
						}
						break;
					case 37:// Cursor left
						break;
					case 39:// Cursor right
						break;
					case 38:// cursor up
						if (e.type == 'keydown') 
						{
							if (Global_objCBOs[Global_CBOname].opened == true)
							{
								// CBO ist offen --> selekted Item verschieben
								Global_objCBOs[Global_CBOname].HighLightItem(Global_objCBOs[Global_CBOname].intHighLightedItem - 1);
							}
							else
							{
								Global_objCBOs[Global_CBOname].open()
							}
						} 
						break;
					case 40:// cursor down			
						if (e.type == 'keydown') 
						{
							if (Global_objCBOs[Global_CBOname].opened == true)
							{
								// CBO ist offen --> selekted Item verschieben
								Global_objCBOs[Global_CBOname].HighLightItem(Global_objCBOs[Global_CBOname].intHighLightedItem + 1);
							}
							else
							{
								Global_objCBOs[Global_CBOname].open()
							}
						} 
						break;
					case 9:	//tab
						if (e.type == 'keydown') 
						{
							if (Global_objCBOs[Global_CBOname].opened) 
							{
								try 
								{		
									//highlighted Item in Textbox bertragen und so auf Actuell  Item setzen
									Global_objCBOs[Global_CBOname].chooseItem(Global_objCBOs[Global_CBOname].Items2show[Global_objCBOs[Global_CBOname].intHighLightedItem].value,Global_objCBOs[Global_CBOname].Items2show[Global_objCBOs[Global_CBOname].intHighLightedItem].text, Global_objCBOs[Global_CBOname].HighLightedItem, Global_objCBOs[Global_CBOname].intHighLightedItem);
								}
								catch(e) {};
								Global_objCBOs[Global_CBOname].toggle(false);
								window.event.returnValue = false;
								window.event.cancelBubble = true;
							}
						}
						break;
					case 8:	//back
							if (e.type == 'keyup') 
							{
								Global_objCBOs[Global_CBOname].blnFiltering = true;
								Global_objCBOs[Global_CBOname].open();
							}
						break;
					default:
						// Eingabe von Buchstaben und Zahlen erzeugt neues Aufbauen der Datengrundlage
						// SC: [57926] habe auerdem die tasten fr das ,, hinzugefgt
						if ((PressedKeyCode > 64 && PressedKeyCode < 91) || (PressedKeyCode > 47 && PressedKeyCode < 58) || (PressedKeyCode == 186) || (PressedKeyCode == 222) || (PressedKeyCode == 192) )
						{
							if (e.type == 'keyup') //keyup
							{
								Global_objCBOs[Global_CBOname].blnFiltering = true;
								Global_objCBOs[Global_CBOname].open();
								
							}
						}
						
						break;
				}
			}
	}
	else
	{
		// Events welche ausgelst werden, wenn Cursor nicht im CBO ist
		switch(PressedKeyCode)
		{
			case 13: // Enter
				if (e.type == 'keydown') 
				{
					if (Global_objCBOs[Global_CBOname])
					{
						if (Global_objCBOs[Global_CBOname].opened) 
						{
							try 
							{		
								//highlighted Item in Textbox bertragen und so auf Actuell  Item setzen
								Global_objCBOs[Global_CBOname].chooseItem(Global_objCBOs[Global_CBOname].Items2show[Global_objCBOs[Global_CBOname].intHighLightedItem].value,Global_objCBOs[Global_CBOname].Items2show[Global_objCBOs[Global_CBOname].intHighLightedItem].text, Global_objCBOs[Global_CBOname].HighLightedItem, Global_objCBOs[Global_CBOname].intHighLightedItem);
							}
							catch(e) {};
							Global_objCBOs[Global_CBOname].toggle(false);
							window.event.returnValue = false;
							window.event.cancelBubble = true;
						}
					}
				}
				break;
			case 27: // Escape
				if (e.type == 'keydown') 
				{
					for (CBOitem in Global_objCBOs)
					{
						Global_objCBOs[CBOitem].toggle(false);									
					}
				}
			case 38: // cursor up
				if (e.type == 'keydown') 
				{
					if (Global_objCBOs[Global_CBOname])
					{
						if (Global_objCBOs[Global_CBOname].opened == true)
						{
							// CBO ist offen --> selekted Item verschieben
							Global_objCBOs[Global_CBOname].HighLightItem(Global_objCBOs[Global_CBOname].intHighLightedItem - 1);
						}
					}
				}
				break;
			case 40: // cursor down			
				if (e.type == 'keydown') 
				{
					if (Global_objCBOs[Global_CBOname])
					{
						if (Global_objCBOs[Global_CBOname].opened == true)
						{
							// CBO ist offen --> selekted Item verschieben
							Global_objCBOs[Global_CBOname].HighLightItem(Global_objCBOs[Global_CBOname].intHighLightedItem + 1);
						}
					}
				}
				break; 
			default:
				break;
		} 
	}
	
}


// Methode wenn onMouseOver ber ein Item --> Markierung
function spComboBox_onMouseOverItem(p_intItemIndex, p_objItem)
{
	// CSS vom alten Item auf deselect setzen
	if(this.HighLightedItem)
	{
		this.HighLightedItem.className = 'combo-item';		
	}
	
	// neues highlighted Item setzen und CSS zuweisen
	this.intHighLightedItem = p_intItemIndex;
	this.HighLightedItem = p_objItem;
	this.HighLightedItem.className =  'combo-hilite';
}



// Markierung des aktiven Items und Positionierung des Layers
function spComboBox_HighLightItem(p_intItemIndex, p_objItem) 
{
   	try 
	{
		// selektiertes Item zurcksetzen
		if(this.HighLightedItem)
		{
			this.HighLightedItem.className =  'combo-item';		
		}
	             
		// wenn letztes Element der Tabelle erreicht dann zu Elemtent 1 springen, wenn 1. Element erreicht ist dann zum letzen springen             
		if (typeof p_intItemIndex == "undefined")
		{
			p_intItemIndex = 0;
		}
		if (p_intItemIndex > this.DataTable.rows.length - 1)
		{
			p_intItemIndex = 0;
		}
		else if (p_intItemIndex < 0)
		{
			p_intItemIndex = this.DataTable.rows.length - 1	
		}
		
		//aktuelles Item holen
			p_objItem = this.DataTable.childNodes[0].rows[p_intItemIndex].cells[0];
			// neues highlighted Item setzen und CSS zuweisen
			this.intHighLightedItem = p_intItemIndex;		
			this.HighLightedItem = p_objItem;
			this.HighLightedItem.className =  'combo-hilite';
			document.getElementById(this.CBOname + '_DatenZelle_' + p_intItemIndex).className = 'combo-hilite';
			
			// DataTableLayer zum Selektiertem Item scrollen 
			this.DataTableLayer.scrollTop = Math.round(p_objItem.offsetTop);
	}
	catch(err) 
	{
		alert("an Error occured in method spComboBox_HighLightItem");
	}
}


//Methode zum setzen des ausgewhlten Items in das Textfeld
function spComboBox_chooseItem(p_strItemValue, p_strItemText, p_objCBOitem, p_intItemID) 
{
	this.value = p_strItemValue;
	this.TextBox.value = p_strItemText;
	this.TextBox.text = p_strItemText;

	try 
	{
		// wenn p_strCBOitem angegeben ist dann wurde Item selektiert und soll als neues aktuelles Item gespeichert werden
		if(arguments.length > 2)
		{ 
			this.ActuellItem		= p_objCBOitem;
			this.HighLightedItem	= p_objCBOitem;
			this.intHighLightedItem = p_intItemID;
			this.intActuellItemIndex= p_intItemID; 

			// Wert ins versteckte textfeld speichern
			if (this.hiddenTextField)
			{
				this.hiddenTextField.value = p_strItemValue;
			}
		}
		
		//ausloesen des postback falls gewuenscht
		if(this.AutoPostBack == true) 
		{
			eval(this.postback.replace('##',p_strItemValue));
		}
	}
	catch(e) 
	{
		alert("Ein Fehler ist in der Methode spComboBox_chooseItem aufgetreten.")
	}
}





/* - - - - - - - - - - - - - - - DatenGrundlage - - - - - - - - - - - - - - */

// Datensource zusammenbauen
function spComboBox_BuildDataSource() 
{
	var opart, strTextBoxValue,intTextBoxValueLenght,opln,intCount,bnlItemExists;
	bnlItemExists = false;
	
	this.Items2show.length = 0;									// clear dA filtered ItemArray
	
	strTextBoxValue  = document.getElementById(this.CBOname + "txt").value;
	intTextBoxValueLenght = strTextBoxValue.length;
	
	if(intTextBoxValueLenght == 0 || this.blnFiltering == false) 
	{
		// Items in Item2show kopieren --> keine Filterung
		for(intCount = 0; intCount < this.Items.length; intCount++) 
		{
			this.Items2show[this.Items2show.length] = this.Items[intCount];
			bnlItemExists = true;
		}
	}
	else 
	{
		// gefilterte Items in Items2show kopieren
		for(intCount = 0; intCount < this.Items.length; intCount++) 
		{
	        opart = this.Items[intCount].text.toLowerCase().substring(0, intTextBoxValueLenght);
		    if(strTextBoxValue.toLowerCase() == opart) 
		    {
				self.status = strTextBoxValue;	
				this.Items2show[this.Items2show.length] = this.Items[intCount];
				bnlItemExists = true;
		    }
		}
	}
	if(!bnlItemExists) 
	{
		this.Items2show[0] = new spComboBoxItem("(keine Eintraege verfuegbar)","");
	}
}

/*------------------------------------------------------------------------------------*/
function strHTMLEncode(strIn)
{
  var strEncoded = strIn.replace(/</g,"&lt;");
  strEncoded = strEncoded.replace(/>/g,"&gt;");
  strEncoded = strEncoded.replace(/ /g,"&nbsp;");
  /*
  strEncoded = strEncoded.replace(//g,"&ouml;");
  strEncoded = strEncoded.replace(//g,"&Ouml;");
  strEncoded = strEncoded.replace(//g,"&uuml;");
  strEncoded = strEncoded.replace(//g,"&Uuml;");
  strEncoded = strEncoded.replace(//g,"&auml;");
  strEncoded = strEncoded.replace(//g,"&Auml;");
  strEncoded = strEncoded.replace(//g,"&szlig;");
  */
  return strEncoded;
}
/*------------------------------------------------------------------------------------*/
function strHTMLDecode(strIn)
{
  var strEncoded = strIn.replace(/&lt;/g,"<");
  strEncoded = strEncoded.replace(/&gt;/g,">");
  strEncoded = strEncoded.replace(/&nbsp;/g," ");
  /*strEncoded = strEncoded.replace(/&ouml;/g,"");
  strEncoded = strEncoded.replace(/&Ouml;/g,"");
  strEncoded = strEncoded.replace(/&uuml;/g,"");
  strEncoded = strEncoded.replace(/&Uuml;/g,"");
  strEncoded = strEncoded.replace(/&auml;/g,"");
  strEncoded = strEncoded.replace(/&Auml;/g,"");
  strEncoded = strEncoded.replace(/&szlig;/g,"");
  */
  return strEncoded;
}
