//Info for PageTypes
var oTempObject

function ShowPageTypeInfo(oObject, sComment, sDivID, sDivinfo)
{
    if(oTempObject == oObject)
    {
        document.getElementById(sDivID).style.visibility = 'hidden';
        oTempObject = null;
    }
    else
    {
        oTempObject = oObject;
        document.getElementById(sDivID).style.visibility = 'visible';
        document.getElementById(sDivID).style.top = oObject.offsetTop + 80;
        document.getElementById(sDivID).style.left = oObject.offsetLeft + 20;
        document.getElementById(sDivinfo).innerHTML  = sComment;
    }
}


//Option Button Div
function ShowOptionButton(strID)
{
    //alert(oObject.offsetLeft);
    if(document.getElementById(strID).style.visibility != 'visible')
    {
        document.getElementById(strID).style.visibility = 'visible';
    }
    else
    {
        document.getElementById(strID).style.visibility = 'hidden';
    }
}


//MainMenuItem Handling
function HighlightMenuItem(oObject)
{
    try
    {
        for(i = 0; i < document.getElementsByTagName("a").length; i++)
        {
            document.getElementsByTagName("a")[i].className = 'MainMenuItem';            
        }
        oObject.className = 'MainMenuItemActive';
    }
    catch(e){}
    finally {}
}
function HighlightMenuItemfromTabPage(strID)
{

    try
    {
        for(i = 0; i < document.getElementsByTagName("a").length; i++)
        {               
            if(document.getElementsByTagName("a")[i].id == strID)
            {
                document.getElementsByTagName("a")[i].className = 'MainMenuItemActive';
            }
            else
            {
                document.getElementsByTagName("a")[i].className = 'MainMenuItem';
            } 
        }
    }
    catch(e){}
    finally {}
}

//Handle the Detailsmenu on TravelOverview
var posX = 100;
var posY = 0;
function ShowDDGSubMenu(strTempInput, strTempInputIsChangable, strIsChangable, strDivID, strID, yCorrect, xCorrect)
{
    //alert(strID);
    document.getElementById(strTempInput).value = strID;
    document.getElementById(strTempInputIsChangable).value = strIsChangable;
    document.getElementById(strDivID).style.visibility = 'visible';
    document.getElementById(strDivID).style.top = (posY + yCorrect) + 'px';
    document.getElementById(strDivID).style.left = (posX - 60 + xCorrect) + 'px';
}


function HideDDGSubMenu(strDivID)
{
    document.getElementById(strDivID).style.visibility = 'hidden';
}

function SetMousePosition(oObject, idParent)
{
    posY = document.getElementById(idParent).offsetTop + oObject.offsetTop;
    posX = document.getElementById(idParent).offsetLeft + oObject.offsetLeft;
    //alert("dsaf");
}

var strInline = "inline";
if (navigator.appName.indexOf('Microsoft') == -1) 
{
    strInline = "table-cell";
}
function SetTravelLinks(strReportID, strReportUrl, strReport2ID, strReport2Url, strDetailsID, strDetailsUrl, strMailID, strMailUrl, strReminderID, strReminderUrl, strChangeID, strDeleteID, strTempInput, virtPath, enableChangeDelete, intStatusID)
{
    var isModal = false;
    var width = 450;
    var height = 300;
    
    //alert(enableChangeDelete);

    var value = document.getElementById(strTempInput).value;
    document.getElementById(strReportID).href = strReportUrl + value;
    document.getElementById(strReport2ID).href = strReport2Url + value;
    document.getElementById(strDetailsID).href = "javascript:OpenModalWindow('', '" + strDetailsUrl + value + "', 'name', 'title'," + width + ", " + height + ", 0, 0," + !isModal + ")";
    document.getElementById(strMailID).href = "javascript:OpenModalWindow('', '" + strMailUrl + value + "', 'name', 'title'," + width + ", " + height + ", 0, 0," + !isModal + ")";
    document.getElementById(strReminderID).href = "javascript:OpenModalWindow('', '" + strReminderUrl + value + "', 'name', 'title'," + width + ", " + height + ", 0, 0," + !isModal + ")";
    if(enableChangeDelete == 'False')
    {                
        document.getElementById('trChange').style.display = "none";
        document.getElementById('trDelete').style.display = "none";
        
        if(document.getElementById('trChangeFast') != null)
            document.getElementById('trChangeFast').style.display = "none";
    }
    else
    {
        document.getElementById('trChange').style.display = strInline;
        document.getElementById('trDelete').style.display = strInline;
        
        if(document.getElementById('trChangeFast') != null)
            document.getElementById('trChangeFast').style.display = strInline;
    }
    if(intStatusID <= 11)
    {
        document.getElementById('trReport1').style.display = "none";
        document.getElementById('trReport2').style.display = strInline;
    }
    else
    {
        document.getElementById('trReport1').style.display = strInline;
        document.getElementById('trReport2').style.display = "none";
    }
}

function SetAppManagerLinks(strReportID, strReportUrl, strMailID, strMailUrl, strReminderID, strReminderUrl, strTempInputID, virtPath, strStatusID, strDivID, hasProofRight, hasAgreeRight)
{
    var isModal = false;
    var width = 450;
    var height = 300;
    var inlineProof = strInline;
    var inlineAgree = strInline;
    
    if(hasProofRight == 'False')
    {
        inlineProof = "none";
    }
    if(hasAgreeRight == 'False')
    {
        inlineAgree = "none";
    }
    
    //alert(enableChangeDelete);

    var value = document.getElementById(strTempInputID).value;
    var strStatusValue = document.getElementById(strStatusID).value;     
    document.getElementById(strDivID).style.left = (posX - 70) + 'px'; 
    
    //alert(strStatusValue);
    
    document.getElementById(strReportID).href = strReportUrl + value;
    document.getElementById(strMailID).href = "javascript:OpenModalWindow('', '" + strMailUrl + value + "', 'name', 'title'," + width + ", " + height + ", 0, 0," + !isModal + ")";
    document.getElementById(strReminderID).href = "javascript:OpenModalWindow('', '" + strReminderUrl + value + "', 'name', 'title'," + width + ", " + height + ", 0, 0," + !isModal + ")";
    switch (strStatusValue)
    {
        case "1": //Antrag erstellt
        document.getElementById('trAgree').style.display = "none";
        document.getElementById('trAllow').style.display = "none";
        document.getElementById('trDeny').style.display = "none";
        break;
        case "2": //AntragBeantragt
        
        document.getElementById('trAllow').style.display = inlineAgree;
        document.getElementById('trDeny').style.display = inlineAgree;
        document.getElementById('trAgree').style.display = inlineProof;
        break;
        
        case "3": //AntragGeprueft
        document.getElementById('trAgree').style.display = "none";        
        document.getElementById('trDeny').style.display = inlineAgree;
        document.getElementById('trAllow').style.display = inlineAgree;
        break;
        
        case "4": //AntragGenehmigt
        document.getElementById('trAgree').style.display = "none";
        document.getElementById('trAllow').style.display = "none";
        document.getElementById('trDeny').style.display = inlineAgree;
        break;
        
        case "5": //AntragAbgelehnt
        document.getElementById('trAgree').style.display = "none";
        document.getElementById('trAllow').style.display = "none";
        document.getElementById('trDeny').style.display = "none";
        break;
        
        default:
        document.getElementById('trAgree').style.display = "none";
        document.getElementById('trAllow').style.display = "none";
        document.getElementById('trDeny').style.display = "none";
        break;
    }
    
}

function SetTravelManagerLinks(strReportID, strReportUrl, strMailID, strMailUrl, strReminderID, strReminderUrl, strTempInputID, virtPath, strDivID, allowClientID, denyClientID, allowAgreement)
{
    var isModal = false;
    var width = 450;
    var height = 300;
    
    if(allowAgreement == 'True')
    {
        document.getElementById(allowClientID).style.display = strInline;
        document.getElementById(denyClientID).style.display = strInline;
    }
    else
    {
        document.getElementById(allowClientID).style.display = "none";
        document.getElementById(denyClientID).style.display = "none";
    }
    
    var value = document.getElementById(strTempInputID).value;
    
    document.getElementById(strReportID).href = strReportUrl + value;
    document.getElementById(strMailID).href = "javascript:OpenModalWindow('', '" + strMailUrl + value + "', 'name', 'title'," + width + ", " + height + ", 0, 0," + !isModal + ")";
    document.getElementById(strReminderID).href = "javascript:OpenModalWindow('', '" + strReminderUrl + value + "', 'name', 'title'," + width + ", " + height + ", 0, 0," + !isModal + ")";
    document.getElementById(strDivID).style.left = (posX - 70) + 'px';
    
}

function SetTravelManagerLinksNew(strReportID, strReportUrl, strMailID, strMailUrl, strReminderID, strReminderUrl, strTempInputID, virtPath, strDivID, strAllowID, strAllowUrl, strDenyID, strDenyUrl, allowAgreement)
{
    var isModal = false;
    var width = 450;
    var height = 300;
    
    if(allowAgreement == '1')
    {
        document.getElementById(strAllowID).style.display = strInline;
        document.getElementById(strDenyID).style.display = strInline;
    }
    else
    {
        document.getElementById(strAllowID).style.display = "none";
        document.getElementById(strDenyID).style.display = "none";
    }
        
    
    var value = document.getElementById(strTempInputID).value;
    
    document.getElementById(strReportID).href = strReportUrl + value;
    document.getElementById(strMailID).href = "javascript:OpenModalWindow('', '" + strMailUrl + value + "', 'name', 'title'," + width + ", " + height + ", 0, 0," + !isModal + ")";
    document.getElementById(strReminderID).href = "javascript:OpenModalWindow('', '" + strReminderUrl + value + "', 'name', 'title'," + width + ", " + height + ", 0, 0," + !isModal + ")";
    document.getElementById(strAllowID).href = "javascript:OpenModalWindow('', '" + strAllowUrl + value + "', 'name', 'title'," + width + ", " + height + ", 0, 0," + !isModal + ")";
    document.getElementById(strDenyID).href = "javascript:OpenModalWindow('', '" + strDenyUrl + value + "', 'name', 'title'," + width + ", " + height + ", 0, 0," + !isModal + ")";
    document.getElementById(strDivID).style.left = (posX - 70) + 'px';
}
function SetTravelManagerLinksNewWithCheck(strReportID, strReportUrl, strMailID, strMailUrl, strReminderID, strReminderUrl, strTempInputID, virtPath, strDivID, strAllowID, strAllowUrl, strDenyID, strDenyUrl, allowAgreement, strCheckID, strCheckUrl, allowCheck)
{
    var isModal = false;
    var width = 450;
    var height = 300;
    
    if(allowCheck == '1')
        document.getElementById(strCheckID).style.display = strInline;
    else
        document.getElementById(strCheckID).style.display = "none";
    
    if(allowAgreement == '1')
    {
        document.getElementById(strAllowID).style.display = strInline;
        document.getElementById(strDenyID).style.display = strInline;
    }
    else
    {
        document.getElementById(strAllowID).style.display = "none";
        document.getElementById(strDenyID).style.display = "none";
    }
        
    
    var value = document.getElementById(strTempInputID).value;
    
    document.getElementById(strReportID).href = strReportUrl + value;
    document.getElementById(strMailID).href = "javascript:OpenModalWindow('', '" + strMailUrl + value + "', 'name', 'title'," + width + ", " + height + ", 0, 0," + !isModal + ")";
    document.getElementById(strReminderID).href = "javascript:OpenModalWindow('', '" + strReminderUrl + value + "', 'name', 'title'," + width + ", " + height + ", 0, 0," + !isModal + ")";
    document.getElementById(strCheckID).href = "javascript:OpenModalWindow('', '" + strCheckUrl + value + "', 'name', 'title'," + width + ", " + height + ", 0, 0," + !isModal + ")";
    document.getElementById(strAllowID).href = "javascript:OpenModalWindow('', '" + strAllowUrl + value + "', 'name', 'title'," + width + ", " + height + ", 0, 0," + !isModal + ")";
    document.getElementById(strDenyID).href = "javascript:OpenModalWindow('', '" + strDenyUrl + value + "', 'name', 'title'," + width + ", " + height + ", 0, 0," + !isModal + ")";
    document.getElementById(strDivID).style.left = (posX - 70) + 'px';
}

function SetBillsManagerLinks(strReportID, strReportUrl, strTempInputID, virtPath, strDivID, strAgreeID, strDenyID, isAgree)
{
    var isModal = false;
    var width = 450;
    var height = 300;
    
    if(isAgree == 'True')
    {
        document.getElementById(strAgreeID).style.display = strInline;
        document.getElementById(strDenyID).style.display = strInline;
    }
    else
    {
        document.getElementById(strAgreeID).style.display = "none";
        document.getElementById(strDenyID).style.display = "none";
    }
    
    var value = document.getElementById(strTempInputID).value;    
    document.getElementById(strReportID).href = strReportUrl + value;   
    document.getElementById(strDivID).style.left = (posX - 60) + 'px'; 
}

function SetObjectiveLinks(strTempInputID,strMailID, strMailUrl, intStatusID, strReminder, strReminderUrl, intDisplayOnly)
{
    var isModal = false;
    var width = 550;
    var height = 300;
            
    var value = document.getElementById(strTempInputID).value;        
    document.getElementById(strMailID).href = "javascript:OpenModalWindow('', '" + strMailUrl + value + "', 'name', 'title'," + width + ", " + height + ", 0, 0," + !isModal + ")";
    document.getElementById(strReminder).href = "javascript:OpenModalWindow('', '" + strReminderUrl + value + "', 'name', 'title'," + width + ", " + height + ", 0, 0," + !isModal + ")";        
    if(intStatusID > 1)
    {                  
       document.getElementById('TrDelete').style.display = "none";               
    }        
    else 
    {           
        document.getElementById('TrDelete').style.display = strInline;         
    }
    
    if (intStatusID <= 1)
    {
        document.getElementById('TrChange').style.display = strInline; 
        document.getElementById('TrGoTo').style.display = "none";         
    }
    else
    {
        document.getElementById('TrChange').style.display = "none"; 
        document.getElementById('TrGoTo').style.display = strInline;     
    }
    if(intDisplayOnly>0)
    {
        document.getElementById('TrChange').style.display = "none"; 
        document.getElementById('TrDelete').style.display = "none"; 
        document.getElementById('TrCopy').style.display = "none"; 
        document.getElementById('TrGoTo').style.display = strInline;     
    }
    
}

function SetMngObjectiveLinks(strTempInputID, intStatusID, strCanEdit)
{
    var isModal = false;
    var width = 450;
    var height = 300;
            
    var value = document.getElementById(strTempInputID).value;        
            
    if(intStatusID > 1)
    {                  
       document.getElementById('TrDelete').style.display = "none";               
    }        
    else 
    {           
        document.getElementById('TrDelete').style.display = strInline;         
    }
    
    if (intStatusID <= 1 || intStatusID == 5)
    {
        document.getElementById('TrChange').style.display = strInline; 
        document.getElementById('TrGoTo').style.display = "none";         
    }
    else
    {
        document.getElementById('TrChange').style.display = "none"; 
        document.getElementById('TrGoTo').style.display = strInline;     
    }    
    
    if (strCanEdit == 'False')
    {
        document.getElementById('TrChange').style.display = "none"; 
        document.getElementById('TrGoTo').style.display = strInline;           
    } 
      
}

function SetMngDepObjectiveLinks(strTempInputID)
{
    var isModal = false;
    var width = 450;
    var height = 300;
            
    var value = document.getElementById(strTempInputID).value; 
   
}


//Sets the focus of a form element

function FocusPopUp()
{
    if (navigator.appName.indexOf('Microsoft') != -1) 
    {
        document.focus();
    }
}


function SetFocus(oElement)
{
    try
    {   
        if(document.getElementById(oElement) != null)
        {
            document.getElementById(oElement).focus();
            document.getElementById(oElement).select();
            
        }    
    }
    catch(e){}
    finally {}
}
 
//Shows or hides the helpPane   
function HandleHelp()
{    
    var oElement = null
    if(window.parent.Content.document.getElementById("HelpPane") != null)
    {
        oElement = window.parent.Content.document.getElementById("HelpPane")
    } 
    if(window.parent.Content.SubPage != null)
    {    
        if(window.parent.Content.SubPage.document.getElementById("HelpPane") != null)
        {
            oElement = window.parent.Content.SubPage.document.getElementById("HelpPane")
        }  
    }     
    if(oElement != null)
    {
        if(oElement.style.display == 'none')
        {            
            try
            {
                oElement.style.display = 'table-cell';
            }
            catch(e)
            {
                oElement.style.display = 'inline';
            }
            finally{}
        }        
        else
        {            
            oElement.style.display = 'none';
        }  
    } 
}

//handles the Tabcontrol
function TabItemChange(oElement, sLink)
{
    try
    {
        for(i = 0; i < document.getElementsByTagName("td").length; i++)
        {
            if(document.getElementsByTagName("td")[i].className == 'TabMenuItemActive')
            {
                document.getElementsByTagName("td")[i].className = 'TabMenuItem';
            }
        }
        oElement.className = 'TabMenuItemActive';
        window.parent.SubPage.location.href = sLink;
    }
    catch(e){}
    finally {}
}

//handles the AdminTabcontrol
function TabAdminItemChange(oElement, sLink)
{
    try
    {
        for(i = 0; i < document.getElementsByTagName("td").length; i++)
        {
            if(document.getElementsByTagName("td")[i].className == 'TabAdminMenuItemActive')
            {
                document.getElementsByTagName("td")[i].className = 'TabAdminMenuItem';
            }
        }
        oElement.className = 'TabAdminMenuItemActive';
        window.parent.SubPage.location.href = sLink;
    }
    catch(e){}
    finally {}
}

//handles the TabcontrolAdmin
function TabItemChangeAdmin(oElement, strElementIDActive)
{

    try
    {
        for(i = 0; i < document.getElementsByTagName("td").length; i++)
        {
            if(document.getElementsByTagName("td")[i].className == 'TabMenuItemActive')
            {
                document.getElementsByTagName("td")[i].className = 'TabMenuItem';
            }
        }
        for(i = 0; i < document.getElementsByTagName("div").length; i++)
        {
            document.getElementsByTagName("div")[i].style.visibility = 'hidden';
        }
        oElement.className = 'TabMenuItemActive';
        document.getElementById(strElementIDActive).style.visibility = 'visible';

    }
    catch(e){}
    finally {}
}

function TabItemRemoteChange(pageID)
{

    try
    {
        for(i = 0; i < document.getElementsByTagName("td").length; i++)
        {
        //alert('sfds');
            if(document.getElementsByTagName("td")[i].className == 'TabMenuItemActive' || document.getElementsByTagName("td")[i].className == 'TabMenuItem')
            {
                document.getElementsByTagName("td")[i].className = 'TabMenuItem';
                if(document.getElementsByTagName("td")[i].id == pageID)
                {
                    document.getElementsByTagName("td")[i].className = 'TabMenuItemActive'
                }
            }
        }
    }
    catch(e){}
    finally {}
}

//Checks if page is in frame
function CheckIsFrame()
{
    try
    {
        CheckIsPopup();
        if (parent.frames.length != 0)
        {
            top.location.href = "login.aspx"
        }
    }
    catch(e){}
    finally {}
    
    
}

function CheckIsPopup()
{
    if(window.opener != null)
    {
//        window.opener.location.reload();
//        window.parent.close();
    }
}

function ShowTooltip(sToolTip)
{
    var top = event.y + 15;
    var left = event.x + 10;
    //alert(document.getElementById('ToolTipContainer').width);
    
    if(left >= (document.body.offsetWidth-120))
    {
        //alert(left + " " +document.body.offsetWidth);
        left = (document.body.offsetWidth-120);
    }
    document.getElementById('ToolTipContainer').innerHTML = "<div style='background-color:white; padding-left:2px;; padding-right:2px; padding-top:1px; padding-bottom:1px;  border:1px solid black; position:absolute; left:" + left + "; top:" + top + "'><table celpadding=0 cellspacing=0><tr><td nowrap=nowrap>" + sToolTip + "</td></tr></table></div>";
}
function HideTooltip()
{
    document.getElementById('ToolTipContainer').innerHTML = "";
}

    
function OpenModalWindow(virtPath, url, name, title, width, height, xPos, yPos, isTest)
{
    x = ((screen.width - width) / 2) + xPos;
    y = ((screen.height - height) / 2) + yPos;    
    
    if (navigator.appName.indexOf('Microsoft') != -1) 
    {
        if(isTest != 1)
        {
            var win = showModalDialog(virtPath + '/Modal.aspx?url=' + url + '&title=' + title, window, 'dialogHeight:' + (height+40) + 'px; dialogWidth: ' + (width+40) + 'px; dialogLeft:' + x + 'px; dialogTop:' + y + 'px; resizable:yes; status:1');
        }
        else
        {
            window.open(virtPath + url, name,  'scrollbars=1,height=' + height + ', width= ' + width + ', status=1, resizable=1');
        }
     
       
    }
    else
    {
       window.open(virtPath + url, name,  'scroll=1,height=' + height + ', width= ' + width + ',resizable=1,DEPENDENT=YES');
    } 
}    

function StartInternalApplication(url)
{
    Win = window.open(url,'AppWin', 'toolbar=0,status=0,menubar=0,scrollbars=1,resizable=1,width=800,height=600,DEPENDENT=YES');
    Win.focus();
}

function fixDialog(p_bEnableContextMenu){
	// just for dialogs, else quit
	try{
		if(dialogArguments==undefined){return}
	}catch(e){return}
	
	p_bEnableContextMenu = (p_bEnableContextMenu==true);	// ensure datatype


	// name window, so we can fix targeting
	if(window.name==''){window.name = "winDialog";}
		
	
	goToURL = function(p_strURL){
		var oLink = document.createElement("A");
		document.body.insertAdjacentElement('beforeEnd', oLink);
		with(oLink){
			href = p_strURL;
			target = window.name;
			click();
		}
	}
	

	// fix window.navigate()
	window.navigate = goToURL; 
	// fix window.location.assign()
	window.location.assign = goToURL; 
	// fix window.location.reload()
	window.location.reload = function(){window.navigate(window.location.href)}
	// fix window.location.replace() (SORTA!)
	window.location.replace = goToURL; 
	
		

	// if window object was passed to vArguments, hook up as window.opener
	// eg:  showModalDialog(sURL, window, sFeatures)
	var bWasPassedWindow = false;
	try{
		bWasPassedWindow = dialogArguments.location!=undefined;
	}catch(e){}


	if(bWasPassedWindow){
		// fix opener
		window.opener = dialogArguments;

		// fix cookies (make available in dialog) 	<--- seems to work fine without this too?
		document.cookie = dialogArguments.document.cookie;
	}



	// fix document stuff
	attachEvent("onload", function(){
	
		// fix form submissions and link openings
		// insert base tag with target (should be faster & work on dynamically created links)
		var oHead = document.getElementsByTagName("HEAD")[0];
		var oBase= document.createElement("BASE");
		oBase.target = window.name;
		oHead.insertAdjacentElement('AfterBegin', oBase);


		// fix U accelerator
		var colUtags = document.all.tags("U");
		for(var u=0; u<colUtags.length; u++){
			if(colUtags[u].style.accelerator){
				colUtags[u].style.textDecoration = 'none';
			}
		}

	});


	// fix keyboard stuff
	document.attachEvent("onkeydown", function(){
//		alert(event.keyCode);
		switch(event.keyCode){
			case 27: {	// enable ESC to close dialog
				close();
				break;
			}

			case 18: {	// alt, recreating accelerator
				if(event.repeat){break}	// ignore if key is held down
				var colUtags = document.all.tags("U");
				for(var u=0; u<colUtags.length; u++){
					if(colUtags[u].style.accelerator){
						colUtags[u].style.textDecoration = (colUtags[u].style.textDecoration!='none') ? 'none': 'underline';	// toggle underline
					}
				}
				setTimeout("document.body.focus();", 200);	// fixes toggle (sorta)
				//event.returnValue = false;
				event.cancelBubble = true;
				//return false;
				break;
			}

			//==== fix reload ====
			case 116: {	// f5 
				window.location.reload();
				break;
			}
			case 82: {	// ctl-R
				if(event.ctrlKey){
				window.location.reload();
				}
				break;
			}

			//==== fix keyboard navigation (does Not work, history object is always empty..) ====
			case 8: {	// backspace
				history.back();
				break;
			}
			case 37: {	// alt-left arrow
				if(event.altKey){history.back();}
				break;
			}
			case 39: {	// alt-right arrow
				if(event.altKey){history.forward();} 
				break;
			}
		}
	});


	


}
    
 